> For the complete documentation index, see [llms.txt](https://docs.divergence-protocol.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.divergence-protocol.com/technical-reference/core/libraries/trademath.md).

# TradeMath

## computeTradeStep

Computes the result of swapping some collateral amount in, or options token amount out, given the parameters of the swap.

```javascript
  function computeTradeStep(ComputeTradeStepParams memory params)
        internal
        pure
        returns (uint160 sqrtRatioNextX96, uint256 amountIn, uint256 amountOut)
```

**Params:**

| **Name**               | **Type** | **Description**                                                                                                                              |
| ---------------------- | -------- | -------------------------------------------------------------------------------------------------------------------------------------------- |
| ComputeTradeStepParams | params   | Params for computing a trade step. See [Params](https://docs.divergence-protocol.com/technical-reference/core/params#ComputeTradeStepParams) |

**Returns:**

| **Name**         | **Type** | **Description**                                                                                |
| ---------------- | -------- | ---------------------------------------------------------------------------------------------- |
| sqrtRatioNextX96 | uint160  | The price after swapping the amount in/out, not to exceed the price target                     |
| amountIn         | uint256  | The collateral amount to be swapped in based on the direction of the swap                      |
| amountOut        | uint256  | The amount to be received, of either spear or shield token, based on the direction of the swap |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.divergence-protocol.com/technical-reference/core/libraries/trademath.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
